## osmium-tool 1.5.1

=== CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
list(APPEND CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake")


#-----------------------------------------------------------------------------
#
#  Project version
#
#-----------------------------------------------------------------------------

# It is important that this setting remains before the "project" call.
set(CMAKE_CONFIGURATION_TYPES "Debug;Release;RelWithDebInfo;MinSizeRel;Dev"
    CACHE STRING
    "List of available configuration types"
    FORCE)

project(osmium)

set(OSMIUM_VERSION_MAJOR 1)
set(OSMIUM_VERSION_MINOR 5)
set(OSMIUM_VERSION_PATCH 1)

set(OSMIUM_VERSION ${OSMIUM_VERSION_MAJOR}.${OSMIUM_VERSION_MINOR}.${OSMIUM_VERSION_PATCH})

set(AUTHOR "Jochen Topf <jochen@topf.org>")

set(CMAKE_EXPORT_COMPILE_COMMANDS ON)


#-----------------------------------------------------------------------------
#
#  Find external dependencies
#
#-----------------------------------------------------------------------------

find_package(Boost 1.55.0 REQUIRED COMPONENTS program_options)
include_directories(SYSTEM ${Boost_INCLUDE_DIRS})

find_package(Osmium 2.11.0 REQUIRED COMPONENTS io)
include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS})


#-----------------------------------------------------------------------------
#
#  Optional "cppcheck" target that checks C++ code
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for cppcheck")
find_program(CPPCHECK cppcheck)

if(CPPCHECK)
    message(STATUS "Looking for cppcheck - found")
    set(CPPCHECK_OPTIONS --enable=warning,style,performance,portability,information,missingInclude)

    # cpp doesn't find system includes for some reason, suppress that report
    set(CPPCHECK_OPTIONS ${CPPCHECK_OPTIONS} --suppress=missingIncludeSystem)

    add_custom_target(cppcheck ${CPPCHECK} --std=c++11 ${CPPCHECK_OPTIONS} ${CMAKE_SOURCE_DIR}/src/*pp)
else()
    message(STATUS "Looking for cppcheck - not found")
    message(STATUS "  Build target 'cppcheck' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "iwyu" target to check headers
#  http://include-what-you-use.org/
#
#-----------------------------------------------------------------------------
find_program(IWYU_TOOL NAMES iwyu_tool iwyu_tool.py)

if(IWYU_TOOL)
    message(STATUS "Looking for iwyu_tool.py - found")
    add_custom_target(iwyu ${IWYU_TOOL} -p ${CMAKE_BINARY_DIR} -- --mapping_file=${CMAKE_SOURCE_DIR}/iwyu.imp)
else()
    message(STATUS "Looking for iwyu_tool.py - not found")
    message(STATUS "  Make target 'iwyu' will not be available")
endif()


#-----------------------------------------------------------------------------
#
#  Optional "man" target to generate man pages
#
#-----------------------------------------------------------------------------
message(STATUS "Looking for pandoc")
find_program(PANDOC pandoc)

function(add_man_page _section _name)
    file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/man/man${_section})
    set(_output_file ${CMAKE_BINARY_DIR}/man/man${_section}/${_name}.${_section})
    set(_source_file ${CMAKE_SOURCE_DIR}/man/${_name}.md)
    set(_dest_file ${CMAKE_BINARY_DIR}/man-source/${_name}.md)
    file(READ ${CMAKE_SOURCE_DIR}/man/common-options.md MAN_COMMON_OPTIONS)
    file(READ ${CMAKE_SOURCE_DIR}/man/progress-options.md MAN_PROGRESS_OPTIONS)
    file(READ ${CMAKE_SOURCE_DIR}/man/input-options.md MAN_INPUT_OPTIONS)
    file(READ ${CMAKE_SOURCE_DIR}/man/output-options.md MAN_OUTPUT_OPTIONS)
    configure_file(${_source_file} ${_dest_file} @ONLY)
    string(TOUPPER ${_name} _name_upcase)
    add_custom_command(OUTPUT ${_output_file}
        COMMAND ${PANDOC}
            ${PANDOC_MAN_OPTIONS}
            --variable "title=${_name_upcase}"
            --variable "section=${_section}"
            -o ${_output_file}
            ${_dest_file}
        DEPENDS ${_source_file} man/manpage.template man/common-options.md man/input-options.md man/output-options.md
        WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
        COMMENT "Building manpage ${_name}.${_section}"
        VERBATIM)
    set(ALL_MAN_PAGES "${ALL_MAN_PAGES};${_output_file}" PARENT_SCOPE)
endfunction()


if(PANDOC)
    message(STATUS "Looking for pandoc - found")
    message(STATUS "  Manual pages will be built")
    set(PANDOC_MAN_OPTIONS
        -s
        -t man
        --template ${CMAKE_CURRENT_SOURCE_DIR}/man/manpage.template
        --variable "description=osmium/${OSMIUM_VERSION}"
        --variable "version=${OSMIUM_VERSION}"
        --variable "author=${AUTHOR}"
    )
    set(PANDOC_HTML_OPTIONS -s -t html)

    add_man_page(1 osmium)
    add_man_page(1 osmium-add-locations-to-ways)
    add_man_page(1 osmium-apply-changes)
    add_man_page(1 osmium-cat)
    add_man_page(1 osmium-changeset-filter)
    add_man_page(1 osmium-check-refs)
    add_man_page(1 osmium-derive-changes)
    add_man_page(1 osmium-diff)
    add_man_page(1 osmium-extract)
    add_man_page(1 osmium-fileinfo)
    add_man_page(1 osmium-getid)
    add_man_page(1 osmium-merge)
    add_man_page(1 osmium-merge-changes)
    add_man_page(1 osmium-renumber)
    add_man_page(1 osmium-show)
    add_man_page(1 osmium-sort)
    add_man_page(1 osmium-time-filter)
    add_man_page(5 osmium-file-formats)

    install(DIRECTORY ${CMAKE_BINARY_DIR}/man DESTINATION share)

    add_custom_target(man ALL DEPENDS ${ALL_MAN_PAGES})
else()
    message(STATUS "Looking for pandoc - not found")
    message(STATUS "  Manual pages will not be built")
endif()


#-----------------------------------------------------------------------------
#
#  Decide which C++ version to use (Minimum/default: C++11).
#
#-----------------------------------------------------------------------------
if(NOT MSVC)
    if(NOT USE_CPP_VERSION)
        set(USE_CPP_VERSION c++11)
    endif()
    message(STATUS "Use C++ version: ${USE_CPP_VERSION}")
    # following only available from cmake 2.8.12:
    #   add_compile_options(-std=${USE_CPP_VERSION})
    # so using this instead:
    add_definitions(-std=${USE_CPP_VERSION})
endif()


#-----------------------------------------------------------------------------
#
#  Compiler and Linker flags
#
#-----------------------------------------------------------------------------
if(MSVC)
    set(USUAL_COMPILE_OPTIONS "/Ox")
else()
    set(USUAL_COMPILE_OPTIONS "-O3 -g")
endif()

if(WIN32)
    add_definitions(-DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32
                    -DWINVER=0x0500 -D_WIN32_WINNT=0x0500 -D_WIN32_IE=0x0600)
endif()

set(CMAKE_CXX_FLAGS_DEV "${USUAL_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during developer builds."
    FORCE)

set(CMAKE_EXE_LINKER_FLAGS_DEV ""
    CACHE STRING "Flags used by the linker during developer builds."
    FORCE)
mark_as_advanced(
    CMAKE_CXX_FLAGS_DEV
    CMAKE_EXE_LINKER_FLAGS_DEV
)

set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "${USUAL_COMPILE_OPTIONS}"
    CACHE STRING "Flags used by the compiler during RELWITHDEBINFO builds."
    FORCE)


#-----------------------------------------------------------------------------
#
#  Build Type
#
#-----------------------------------------------------------------------------

add_definitions(${OSMIUM_WARNING_OPTIONS})

# In 'Dev' mode: compile with very strict warnings and turn them into errors.
if(CMAKE_BUILD_TYPE STREQUAL "Dev")
    if(NOT MSVC)
        add_definitions(-Werror)
    endif()
endif()

# Force RelWithDebInfo build type if none was given
if(CMAKE_BUILD_TYPE)
    set(build_type ${CMAKE_BUILD_TYPE})
else()
    set(build_type "RelWithDebInfo")
endif()

set(CMAKE_BUILD_TYPE ${build_type}
    CACHE STRING
    "Choose the type of build, options are: ${CMAKE_CONFIGURATION_TYPES}."
    FORCE)

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")


#-----------------------------------------------------------------------------
#
#  Version
#
#-----------------------------------------------------------------------------

find_package(Git)

if(GIT_FOUND)
    execute_process(COMMAND "${GIT_EXECUTABLE}" describe --tags --dirty=-changed
                    WORKING_DIRECTORY "${CMAKE_SOURCE_DIR}"
                    OUTPUT_VARIABLE VERSION_FROM_GIT
                    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
    if(VERSION_FROM_GIT)
        set(VERSION_FROM_GIT " (${VERSION_FROM_GIT})")
    endif()
endif()

configure_file(
    ${PROJECT_SOURCE_DIR}/src/version.cpp.in
    ${PROJECT_BINARY_DIR}/src/version.cpp
)

#-----------------------------------------------------------------------------

configure_file(
    ${PROJECT_SOURCE_DIR}/osmium-wrapper.in
    ${PROJECT_BINARY_DIR}/osmium
)

include_directories(SYSTEM include)
include_directories(${PROJECT_BINARY_DIR}/src)

#-----------------------------------------------------------------------------
#
#  Tests
#
#-----------------------------------------------------------------------------

enable_testing()
add_subdirectory(test)

#-----------------------------------------------------------------------------

add_subdirectory(src)


#-----------------------------------------------------------------------------

=== src/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

file(GLOB OSMIUM_SOURCE_FILES *.cpp extract/*.cpp ${PROJECT_BINARY_DIR}/src/version.cpp)

add_executable(osmium ${OSMIUM_SOURCE_FILES})

target_link_libraries(osmium ${Boost_LIBRARIES} ${OSMIUM_LIBRARIES})

install(TARGETS osmium DESTINATION bin)

=== test/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests
#
#-----------------------------------------------------------------------------

include_directories(include)
include_directories(../src)
include_directories(../src/extract)
include_directories(../include)

file(GLOB ALL_UNIT_TESTS */test_setup.cpp */test_unit.cpp)
file(GLOB ALL_COMMANDS ../src/command_*.cpp ../src/io.cpp ../src/cmd.cpp ../src/cmd_factory.cpp ../src/util.cpp ../src/extract/*.cpp)
add_executable(unit_tests unit_tests.cpp ${ALL_COMMANDS} ${ALL_UNIT_TESTS} ${PROJECT_BINARY_DIR}/src/version.cpp)
target_link_libraries(unit_tests ${Boost_LIBRARIES} ${OSMIUM_LIBRARIES})
add_test(NAME unit_tests COMMAND unit_tests WORKING_DIRECTORY "${PROJECT_SOURCE_DIR}")


#-----------------------------------------------------------------------------

configure_file(io/Makefile.in ${CMAKE_CURRENT_BINARY_DIR}/io/Makefile @ONLY)

#-----------------------------------------------------------------------------

function(do_test _name _command _regex)
    separate_arguments(_command)
    add_test(NAME ${_name} COMMAND ${_command})
    set_tests_properties(${_name} PROPERTIES
                         ENVIRONMENT "MANPATH=${PROJECT_BINARY_DIR}/man"
                         PASS_REGULAR_EXPRESSION ${_regex}
    )
endfunction()

#-----------------------------------------------------------------------------

function(check_output _dir _name _command _reference)
    set(_cmd "$<TARGET_FILE:osmium> ${_command}")
    add_test(
        NAME "${_dir}-${_name}"
        COMMAND ${CMAKE_COMMAND}
        -D cmd:FILEPATH=${_cmd}
        -D dir:PATH=${PROJECT_SOURCE_DIR}/test
        -D reference:FILEPATH=${PROJECT_SOURCE_DIR}/test/${_reference}
        -D output:FILEPATH=${PROJECT_BINARY_DIR}/test/${_dir}/cmd-output-${_name}
        -P ${CMAKE_SOURCE_DIR}/cmake/run_test_compare_output.cmake
    )
endfunction()

function(check_output2 _dir _name _tmpdir _command1 _command2 _reference)
    set(_cmd1 "$<TARGET_FILE:osmium> ${_command1}")
    set(_cmd2 "$<TARGET_FILE:osmium> ${_command2}")
    add_test(
        NAME "${_dir}-${_name}"
        COMMAND ${CMAKE_COMMAND}
        -D cmd:FILEPATH=${_cmd1}
        -D cmd2:FILEPATH=${_cmd2}
        -D dir:PATH=${PROJECT_SOURCE_DIR}/test
        -D tmpdir:PATH=${_tmpdir}
        -D reference:FILEPATH=${PROJECT_SOURCE_DIR}/test/${_reference}
        -D output:FILEPATH=${PROJECT_BINARY_DIR}/test/${_dir}/cmd-output-${_name}
        -P ${CMAKE_SOURCE_DIR}/cmake/run_test_compare_output.cmake
    )
endfunction()


#-----------------------------------------------------------------------------
#
#  Check "osmium SUBCOMMAND -h" for most subcommands.
#
#-----------------------------------------------------------------------------
function(check_cmd_help _command)
    do_test(help_cmd_${_command} "osmium ${_command} -h" "Usage: osmium ${_command}.*OPTIONS:")
endfunction()

check_cmd_help(add-locations-to-ways)
check_cmd_help(apply-changes)
check_cmd_help(cat)
check_cmd_help(changeset-filter)
check_cmd_help(check-refs)
check_cmd_help(derive-changes)
check_cmd_help(diff)
check_cmd_help(fileinfo)
check_cmd_help(getid)
check_cmd_help(merge)
check_cmd_help(merge-changes)
check_cmd_help(renumber)
check_cmd_help(show)
check_cmd_help(sort)
check_cmd_help(time-filter)


#-----------------------------------------------------------------------------
#
#  Configure tests in all subdirectories
#
#-----------------------------------------------------------------------------

file(GLOB _testcmakes "test" "*/CMakeLists.txt")

foreach(_tc IN LISTS _testcmakes)
    string(REPLACE "/CMakeLists.txt" "" _dir ${_tc})
    message(STATUS "Adding tests in ${_dir}")
    add_subdirectory(${_dir})
endforeach()


#-----------------------------------------------------------------------------

=== test/add-locations-to-ways/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - add-locations-to-ways
#
#-----------------------------------------------------------------------------

function(check_add_locations_to_ways _name _options _input _output)
    check_output(add-locations-to-ways ${_name} "add-locations-to-ways ${_options} --generator=test --output-format=xml add-locations-to-ways/${_input}" "add-locations-to-ways/${_output}")
endfunction()

check_add_locations_to_ways(taggednodes "" input.osm output.osm)
check_add_locations_to_ways(allnodes "-n" input.osm output-n.osm)


#-----------------------------------------------------------------------------

=== test/apply-changes/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - apply-changes
#
#-----------------------------------------------------------------------------

function(check_apply_changes _name _options _input _change _type _output)
    check_output(apply-changes ${_name} "apply-changes ${_options} --generator=test -f ${_type} apply-changes/${_input} apply-changes/${_change}" "apply-changes/${_output}")
endfunction()

check_apply_changes(data              ""                            input-data.osm input-change.osc "osm" output-data.osm)

add_test(NAME check-apply-changes-mixed1 COMMAND osmium apply-changes ${CMAKE_SOURCE_DIR}/test/apply-changes/input-data.osm ${CMAKE_SOURCE_DIR}/test/apply-changes/input-changes.osc -f osh)
set_tests_properties(check-apply-changes-mixed1 PROPERTIES WILL_FAIL true)

add_test(NAME check-apply-changes-mixed2 COMMAND osmium apply-changes ${CMAKE_SOURCE_DIR}/test/apply-changes/input-data.osh ${CMAKE_SOURCE_DIR}/test/apply-changes/input-changes.osc -f osm)
set_tests_properties(check-apply-changes-mixed2 PROPERTIES WILL_FAIL true)

check_apply_changes(history-osh-osh    ""               input-history.osh input-change.osc "osh" output-history.osh)
check_apply_changes(history-osh-osh-wh "--with-history" input-history.osh input-change.osc "osh" output-history.osh)
check_apply_changes(history-osm-osh-wh "--with-history" input-history.osm input-change.osc "osh" output-history.osh)
check_apply_changes(history-osh-osm-wh "--with-history" input-history.osh input-change.osc "osm" output-history.osh)


#-----------------------------------------------------------------------------

=== test/getid/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - getid
#
#-----------------------------------------------------------------------------

function(check_getid _name _input _output)
    check_output(getid ${_name} "getid --generator=test -f osm getid/${_input} n11,n12 w21" "getid/${_output}")
endfunction()

function(check_getid_file _name _file _input _output)
    check_output(getid ${_name} "getid --generator=test -i getid/${_file} -f osm getid/${_input}" "getid/${_output}")
endfunction()

check_getid(n input.osm output.osm)
check_getid_file(file1 idfile input.osm output.osm)

#-----------------------------------------------------------------------------

function(check_getid_r _name _source _input _output)
    check_output(getid ${_name}   "getid -r --generator=test -f osm getid/${_source}.osm -I getid/${_input}.osm" "getid/${_output}.osm")
    check_output(getid ${_name}-i "getid -r --generator=test -f osm getid/${_source}.osm -i getid/${_input}.id"  "getid/${_output}.osm")
endfunction()

check_getid_r(n10 source in10 out10)
check_getid_r(w21 source in21 out21)
check_getid_r(r30 source in30 out30)
check_getid_r(r31 source in31 out31)
check_getid_r(r32 source in32 out32)

check_getid_r(n10nrr source-no-rr in10 out10)
check_getid_r(w21nrr source-no-rr in21 out21)
check_getid_r(r30nrr source-no-rr in30 out30)
check_getid_r(r32nrr source-no-rr in32 out32)

check_getid_r(missing-n19 source in19 out31)
set_tests_properties(getid-missing-n19 PROPERTIES WILL_FAIL true)
set_tests_properties(getid-missing-n19-i PROPERTIES WILL_FAIL true)

check_getid_r(missing-w29 source in29 out31)
set_tests_properties(getid-missing-w29 PROPERTIES WILL_FAIL true)
set_tests_properties(getid-missing-w29-i PROPERTIES WILL_FAIL true)

check_getid_r(missing-r39 source in39 out31)
set_tests_properties(getid-missing-r39 PROPERTIES WILL_FAIL true)
set_tests_properties(getid-missing-r39-i PROPERTIES WILL_FAIL true)

check_getid_r(relloop relloop relloop relloop-out)


#-----------------------------------------------------------------------------

=== test/merge/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - getid
#
#-----------------------------------------------------------------------------

function(check_merge1 _name _input1 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1}" "merge/${_output}")
endfunction()

function(check_merge2 _name _input1 _input2 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1} merge/${_input2}" "merge/${_output}")
endfunction()

function(check_merge3 _name _input1 _input2 _input3 _output)
    check_output(merge ${_name} "merge --generator=test -f osm merge/${_input1} merge/${_input2} merge/${_input3}" "merge/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_merge1(i1 input1.osm output1.osm)
check_merge2(i2f input1.osm input2.osm output2.osm)
check_merge2(i2r input2.osm input1.osm output2.osm)
check_merge3(i3f input1.osm input2.osm input3.osm output3.osm)


#-----------------------------------------------------------------------------

=== test/renumber/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - renumber
#
#-----------------------------------------------------------------------------

function(check_renumber _name _input _output)
    check_output(renumber ${_name} "renumber --generator=test -f osm renumber/${_input}" "renumber/${_output}")
endfunction()

function(check_renumber_nodes _name _input _output)
    check_output(renumber ${_name} "renumber --generator=test -t node -f osm renumber/${_input}" "renumber/${_output}")
endfunction()

function(check_renumber2 _name _in1 _in2 _out)
    set(_idxdir "${PROJECT_BINARY_DIR}/test/renumber/index")
    if(WIN32)
        set(_devnull "nul")
    else()
        set(_devnull "/dev/null")
    endif()
    check_output2(renumber ${_name} ${_idxdir}
                  "renumber --index-directory=${_idxdir} --generator=test -f osm --overwrite -o ${_devnull} renumber/${_in1}"
                  "renumber --index-directory=${_idxdir} --generator=test -f osc renumber/${_in2}"
                  "renumber/${_out}"
    )
endfunction()

check_renumber(sorted input-sorted.osm output-sorted.osm)
check_renumber_nodes(nodes-sorted input-sorted.osm output-sorted-n.osm)

check_renumber2(change input-sorted.osm input-change.osc output-change.osc)

#-----------------------------------------------------------------------------

# input data not ordered properly

add_test(NAME renumber-fail-order-n COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-n.osm -f osm)
set_tests_properties(renumber-fail-order-n PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-w COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-w.osm -f osm)
set_tests_properties(renumber-fail-order-w PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-r COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-r.osm -f osm)
set_tests_properties(renumber-fail-order-r PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-wn COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-wn.osm -f osm)
set_tests_properties(renumber-fail-order-wn PROPERTIES WILL_FAIL true)

add_test(NAME renumber-fail-order-rw COMMAND osmium renumber ${CMAKE_SOURCE_DIR}/test/order/fail-order-rw.osm -f osm)
set_tests_properties(renumber-fail-order-rw PROPERTIES WILL_FAIL true)


#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.5.1-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 20 Jan 2017 17:46:15 +0100

osmium-tool (1.5.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Jan 2017 16:46:03 +0100

osmium-tool (1.5.0-1~exp2) experimental; urgency=medium

  * Bump minimum required libosmium2-dev to 2.11.0.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 19 Jan 2017 00:38:26 +0100

osmium-tool (1.5.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update copyright years for Jochen Topf.
  * Include extract config examples.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 18 Jan 2017 20:35:07 +0100

osmium-tool (1.4.1-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 21 Nov 2016 07:19:28 +0100

osmium-tool (1.4.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Drop patches, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 20 Nov 2016 19:58:02 +0100

osmium-tool (1.4.0-3~exp1) experimental; urgency=medium

  * Add patch for libosmium 2.10.2 support.
  * Bump minimum required libosmium2-dev to 2.10.2.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 17 Nov 2016 19:58:08 +0100

osmium-tool (1.4.0-2) unstable; urgency=medium

  * Ignore test failures on problematic architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 16 Sep 2016 20:25:16 +0200

osmium-tool (1.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Update Homepage URL.
  * Include CONTRIBUTING.md in docs.
  * Update copyright file, changes:
    - Rename MIT license shortname to Expat
    - Add THL A29 Limited to copyright holders for msinttypes files
  * Bump minimum required libosmium2-dev to 2.9.0.
  * Drop output-typo.patch, applied upstream.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 15 Sep 2016 16:35:18 +0200

osmium-tool (1.3.1-2) unstable; urgency=medium

  * Rebuild with libosmium 2.8.0, for long strings overflow fix.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 08 Aug 2016 15:54:59 +0200

=== debian/control ===
Source: osmium-tool
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper (>= 9),
               cmake,
               libboost-dev,
               libboost-program-options-dev,
               libbz2-dev,
               libexpat1-dev,
               libosmium2-dev (>= 2.11.0),
               pandoc,
               zlib1g-dev
Standards-Version: 3.9.8
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/osmium-tool.git/
Vcs-Git: https://anonscm.debian.org/git/pkg-grass/osmium-tool.git
Homepage: http://osmcode.org/osmium-tool/

Package: osmium-tool
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Command line tool for working with OpenStreetMap data
 Osmium Tool is a multipurpose command line tool based on the Osmium library.
 .
 With the Osmium Tool you currently can:
 .
  * Get information about an OSM file
  * Convert OSM files from one format into another (supports all XML and PBF
    formats)
  * Merge and apply change files to an OSM file (with or without history)
  * Extract data from OSM history files for a given point in time or a time
    range
 .
 The Osmium library has extensive support for all types of OSM entities: nodes,
 ways, relations, and changesets. It allows reading from and writing to OSM
 files in XML and PBF formats, including change files and full history files.
 Osmium can store OSM data in memory and on disk in various formats and using
 various indexes. Its easy to use handler interface allows you to quickly write
 data filtering and conversion functions. Osmium can create WKT, WKB, OGR, GEOS
 and GeoJSON geometries for easy conversion into many GIS formats and it can
 assemble multipolygons from ways and relations.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

# Verbose make output
export VERBOSE=1

DEB_BUILD_ARCH ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)

%:
	dh $@ --buildsystem cmake \
	      --parallel

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_VERBOSE_MAKEFILE=1

override_dh_auto_test:
# Ignore test failures on problematic architectures only
ifneq (,$(findstring $(DEB_BUILD_ARCH),"mips mipsel"))
	dh_auto_test || echo "Ignoring test failures"
else
	dh_auto_test
endif

override_dh_installchangelogs:
	dh_installchangelogs -k CHANGELOG.md

## osmium-tool 1.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,8 +25,8 @@
 project(osmium)
 
 set(OSMIUM_VERSION_MAJOR 1)
-set(OSMIUM_VERSION_MINOR 5)
-set(OSMIUM_VERSION_PATCH 1)
+set(OSMIUM_VERSION_MINOR 7)
+set(OSMIUM_VERSION_PATCH 0)
 
 set(OSMIUM_VERSION ${OSMIUM_VERSION_MAJOR}.${OSMIUM_VERSION_MINOR}.${OSMIUM_VERSION_PATCH})
 
@@ -44,7 +44,7 @@
 find_package(Boost 1.55.0 REQUIRED COMPONENTS program_options)
 include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
 
-find_package(Osmium 2.11.0 REQUIRED COMPONENTS io)
+find_package(Osmium 2.13.0 REQUIRED COMPONENTS io)
 include_directories(SYSTEM ${OSMIUM_INCLUDE_DIRS})
 
 
@@ -104,6 +104,7 @@
     file(READ ${CMAKE_SOURCE_DIR}/man/progress-options.md MAN_PROGRESS_OPTIONS)
     file(READ ${CMAKE_SOURCE_DIR}/man/input-options.md MAN_INPUT_OPTIONS)
     file(READ ${CMAKE_SOURCE_DIR}/man/output-options.md MAN_OUTPUT_OPTIONS)
+    file(READ ${CMAKE_SOURCE_DIR}/export-example-config/default-config.json EXPORT_DEFAULT_CONFIG)
     configure_file(${_source_file} ${_dest_file} @ONLY)
     string(TOUPPER ${_name} _name_upcase)
     add_custom_command(OUTPUT ${_output_file}
@@ -142,6 +143,7 @@
     add_man_page(1 osmium-check-refs)
     add_man_page(1 osmium-derive-changes)
     add_man_page(1 osmium-diff)
+    add_man_page(1 osmium-export)
     add_man_page(1 osmium-extract)
     add_man_page(1 osmium-fileinfo)
     add_man_page(1 osmium-getid)
@@ -150,8 +152,10 @@
     add_man_page(1 osmium-renumber)
     add_man_page(1 osmium-show)
     add_man_page(1 osmium-sort)
+    add_man_page(1 osmium-tags-filter)
     add_man_page(1 osmium-time-filter)
     add_man_page(5 osmium-file-formats)
+    add_man_page(5 osmium-index-types)
 
     install(DIRECTORY ${CMAKE_BINARY_DIR}/man DESTINATION share)
 
@@ -191,8 +195,7 @@
 endif()
 
 if(WIN32)
-    add_definitions(-DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32
-                    -DWINVER=0x0500 -D_WIN32_WINNT=0x0500 -D_WIN32_IE=0x0600)
+    add_definitions(-DWIN32 -D_WIN32 -DMSWIN32 -DBGDWIN32)
 endif()
 
 set(CMAKE_CXX_FLAGS_DEV "${USUAL_COMPILE_OPTIONS}"

=== src/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool
#
#-----------------------------------------------------------------------------

file(GLOB OSMIUM_SOURCE_FILES *.cpp */*.cpp ${PROJECT_BINARY_DIR}/src/version.cpp)

add_executable(osmium ${OSMIUM_SOURCE_FILES})

target_link_libraries(osmium ${Boost_LIBRARIES} ${OSMIUM_LIBRARIES})

set_pthread_on_target(osmium)

install(TARGETS osmium DESTINATION bin)

=== test/extract/CMakeLists.txt ===
#-----------------------------------------------------------------------------
#
#  CMake Config
#
#  Osmium Tool Tests - extract
#
#-----------------------------------------------------------------------------

function(check_extract _name _input _output _opts)
    check_output(extract ${_name} "extract --generator=test -f osm extract/${_input} ${_opts} -b 0,0,1.5,10" "extract/${_output}")
endfunction()


#-----------------------------------------------------------------------------

check_extract(simple        input1.osm output-simple.osm "-s simple")
check_extract(complete_ways input1.osm output-complete-ways.osm "-s complete_ways")
check_extract(smart_default input1.osm output-smart.osm "-s smart")
check_extract(smart_mp      input1.osm output-smart.osm "-s smart -S types=multipolygon")
check_extract(smart_any     input1.osm output-smart.osm "-s smart -S types=any")
check_extract(smart_nonmp   input1.osm output-smart-nonmp.osm "-s smart -S types=x")


#-----------------------------------------------------------------------------

=== debian/changelog ===
osmium-tool (1.7.0-2) unstable; urgency=medium

  * Ignore test failures on mips64el.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 16 Aug 2017 23:21:31 +0200

osmium-tool (1.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.13.0.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 15 Aug 2017 19:33:10 +0200

osmium-tool (1.6.1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.0.0, no changes.
  * Add autopkgtest to test installability.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 25 Jun 2017 20:56:07 +0200

osmium-tool (1.6.1-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 18 Jun 2017 12:39:49 +0200

osmium-tool (1.6.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.12.1.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 10 Apr 2017 19:57:22 +0200

osmium-tool (1.6.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Bump minimum required libosmium2-dev to 2.12.0.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 07 Mar 2017 19:03:31 +0100

=== debian/control ===
--- 
+++ 
@@ -9,10 +9,10 @@
                libboost-program-options-dev,
                libbz2-dev,
                libexpat1-dev,
-               libosmium2-dev (>= 2.11.0),
+               libosmium2-dev (>= 2.13.0),
                pandoc,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-grass/osmium-tool.git/
 Vcs-Git: https://anonscm.debian.org/git/pkg-grass/osmium-tool.git
 Homepage: http://osmcode.org/osmium-tool/
